﻿using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Selection;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGExcelLikeSummary
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void xamDataGrid1_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {
            this.sumTB.Text = "";
            this.averageTB.Text = "";
            this.countTB.Text = "";

            (e.OriginalSource as XamDataGrid).ActiveRecord = null;
            SelectedCellCollection scc = (e.OriginalSource as XamDataGrid).SelectedItems.Cells;

            if(scc == null)
                return;

            List<int> selectedNumericCellsValues = new List<int>();
            List<string> selectedOtherCellsValues = new List<string>();

            foreach (var cell in scc)
            {
                if (Type.GetTypeCode(cell.Field.DataType) == TypeCode.Int32)
                    selectedNumericCellsValues.Add(Int32.Parse(cell.Value.ToString()));
                else
                    selectedOtherCellsValues.Add(cell.Value.ToString());
            }
           
            this.countTB.Text = (selectedNumericCellsValues.Count() + selectedOtherCellsValues.Count()).ToString();

            if (selectedNumericCellsValues.Count != 0)
            {
                this.sumTB.Text = selectedNumericCellsValues.Sum().ToString();
                this.averageTB.Text = selectedNumericCellsValues.Average().ToString();
            }

        }
    }
}
